#include <vdi.h>
#include <aes.h>
#include <stdio.h>
#include <stdlib.h>
#include <tos.h>
#include "lilo.h"


#define WAIT					3
#define RSC_FILE			"lilo.rsc"
#define BOOT_PRG			"ataboot.ttp"
#define ARG_FILE			"bootargs"
#define TEMPLATE_FILE	"bootargs.t"


int work_in [64], work_out [64];
int vwkd = -1;
int appld = -1;


void fatal (const char *msg) {
	char buf [128];
	sprintf (buf, "[1][%s][Ok]", msg);
	form_alert (1, buf);
	if (vwkd != -1) v_clsvwk (vwkd);
	appl_exit ();
	exit (1);
}


int ld (int x) {
	int l = 0;
	
	while (x > 1) {
		x /= 2;
		l ++;
	}

	return l;

}


void set_count_field (OBJECT *box, int count) {
	sprintf (box [COUNT_FIELD].ob_spec.tedinfo->te_ptext, "%2d", count);
}


int main () {
	FILE *fd;
	int msg [8], dummy;
	char buf [128];
	OBJECT *box;
	int x, y, w, h;
	int count;
	
	appld = appl_init ();

	if (!rsrc_load (RSC_FILE)) fatal ("Loading '"RSC_FILE"' failed");

	v_opnvwk (work_in, &vwkd, work_out);
	if (!vwkd) fatal ("Opening VDI workstation failed");

	fd = fopen (TEMPLATE_FILE, "r");
	if (!fd) fatal ("Opening '"TEMPLATE_FILE"' failed");
	buf [fread (buf, sizeof (char), sizeof (buf) - 1, fd)] = 0;
	fclose (fd);
	
	fd = fopen (ARG_FILE, "w");
	if (!fd) fatal ("Opening '"ARG_FILE"' failed");
	if (EOF == fprintf (fd, buf,
		work_out [0] + 1, work_out [1] + 1, ld (work_out [13])))
		fatal ("Writing '"ARG_FILE"' failed");
	if (EOF == fclose (fd)) fatal ("Closing '"ARG_FILE"' failed");
	
	rsrc_gaddr (0, COUNT_BOX, &box);
	form_center (box, &x, &y, &w, &h);
	set_count_field (box, WAIT);
	objc_draw (box, 0, 8, x, y, w, h);

	count = WAIT;
	while (count > 0) {
		switch (evnt_multi (MU_KEYBD | MU_BUTTON | MU_TIMER,
			1, 1, 1,
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			msg,
			1000, 0,
			&dummy, &dummy, &dummy, &dummy, &dummy, &dummy)) {
		case MU_KEYBD:
		case MU_BUTTON: count = 0; break;
		case MU_TIMER:
			count --;
			set_count_field (box, count);
			objc_draw (box, COUNT_FIELD, 8, x, y, w, h);
			if (count == 0) {
				graf_mouse (M_OFF, 0);
				v_clrwk (vwkd);
				graf_mouse (M_ON, 0);
				Pexec(0, BOOT_PRG, "", _BasPag->p_env);
				fatal ("Executing '"BOOT_PRG"' failed");
			}
		}
	}
	
	v_clsvwk (vwkd);
	rsrc_free ();
	appl_exit ();

	return 0;
}
